/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#include <doca_error.h>
#include <doca_log.h>
#include "buf_extensions.hpp"
#include "buf_extensions_map.hpp"

DOCA_LOG_REGISTER(CORE::BUF_EXTENSIONS_MAP);

doca_core::buf_extensions_map::buf_extensions_map(
	uint32_t extensions_flags, const supported_extensions_attributes &extensions_attributes)
	: m_extensions_flags(extensions_flags)
{
	size_t offset{0};

	for (auto &attributes : extensions_attributes) {
		if (extensions_flags & static_cast<uint32_t>(attributes.extension_flag)) {
			auto entry = &m_offsets[static_cast<uint32_t>(attributes.type)];
			entry->offset = offset;
			entry->valid = 1;
			entry->size = attributes.size;
			offset += attributes.size;
		}
	}
 }

