/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#pragma once

#include <memory>
#include <utility>

#include <doca_error.h>

namespace device_abstraction {

class ievents_mux;

using create_mux_ret = std::pair<doca_error_t, ievents_mux *>;

/**
 * @brief This method creates and initializes an empty event mux.
 *
 * @return create_mux_ret see above.
 */
create_mux_ret create_events_mux() noexcept;

} /* namespace device_abstraction */
