/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#include <memory>
#include <utility>
#include <new>

#include "linux_events_mux.hpp"
#include <ievents_mux.hpp>

#include <doca_error.h>

#include <events_mux_factory.hpp>

using namespace device_abstraction;

create_mux_ret
device_abstraction::create_events_mux() noexcept
{
	auto tmp_mux = new (std::nothrow) linux_events_mux();

	return create_mux_ret{tmp_mux == nullptr ? DOCA_ERROR_NO_MEMORY : tmp_mux->initialize(), tmp_mux};
}


