/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef PRIV_DOCA_MALLOC_H_
#define PRIV_DOCA_MALLOC_H_

#include <stdint.h>
#include <stddef.h>

#include <priv_doca_compat.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Allocates @count elements each element with the size of @size bytes.
 * Memory initialized to 0.
 *
 * Please use this method over malloc/calloc.
 */
DOCA_PRIVATE
void *priv_doca_malloc(size_t count, size_t size);
DOCA_PRIVATE
void priv_doca_free(void *ptr);

#ifdef __cplusplus
}
#endif

#endif /* PRIV_DOCA_MALLOC_H_ */
