/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#pragma once

#include <stdint.h>
#include <doca_error.h>

namespace os_abstraction
{

/**
 * @brief This method finds the first set bit.
 * @param [in] mask
 * @return position of first bit (least significant is 1, most significant is 64), 0 if input is 0.
 */
uint32_t priv_doca_bit_scan_forward(uint64_t mask);

/**
 * @brief This method finds the last set bit.
 * @param [in] mask
 * @return position of last bit (least significant is 1, most significant is 64), 0 if input is 0.
 */
uint32_t priv_doca_bit_scan_reverse(uint64_t mask);

} // namespace os_abstraction
