/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#pragma once

#include <stddef.h>
#include <private/common_defines.h>
#include <priv_doca_compat.h>

namespace os_abstraction
{

/**
 * @brief This method wraps or implements stlrcpy
 * @param [in] destination
 * @param [in] source
 * @param [in] source size
 * @return actual source size
 */
DOCA_PRIVATE
size_t priv_doca_strlcpy(char *dst, const char *src, size_t size);

} // namespace os_abstraction