/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#pragma once

#include <stdint.h>
#include <time.h>
#include <doca_error.h>
#include <private/common_defines.h>

namespace os_abstraction
{

/**
 * @brief This method retrieves the local time
 * @param [out] local time
 * @param [out] usec
 * @return DOCA_SUCCESS or DOCA_ERROR_OPERATING_SYSTEM in case of failure.
 */
doca_error_t priv_doca_localtime(struct tm &time, uint32_t &usec);

} // namespace os_abstraction
