/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#include <sys/time.h>

#include <priv_doca_os_abstraction_time.hpp>

doca_error_t
os_abstraction::priv_doca_localtime(struct tm &time, uint32_t &usec)
{
	struct timeval timeval;
	gettimeofday(&timeval, nullptr);
	usec = 0;

	auto local_time = localtime(&timeval.tv_sec);
	if (likely(local_time != nullptr)) {
		time = *local_time;
		usec = timeval.tv_usec;
		return DOCA_SUCCESS;
	} else
		return DOCA_ERROR_OPERATING_SYSTEM;
}

