/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DPDK_SHARED_COUNTER_H_
#define DPDK_SHARED_COUNTER_H_

#include "dpdk_resource_manager.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief Get ops of shared counter
 *
 * @return
 * Pointer to ops, null on error.
 */
struct dpdk_resource_manager_ops *
dpdk_shared_counter_get_ops();

/**
 * @brief Get the shared counter indirect action handle
 *
 * @return
 * Pointer to shared counter handle, null on error.
 */
struct rte_flow_action_handle *
dpdk_shared_counter_get_conf(uint32_t counter_id);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* DPDK_SHARED_COUNTER_H_ */
