/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DPDK_SHARED_RSS_H_
#define DPDK_SHARED_RSS_H_

#include "dpdk_resource_manager.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief Get ops of shared rss
 *
 * @return
 * Pointer to ops, null on error.
 */
struct dpdk_resource_manager_ops *
dpdk_shared_rss_get_ops();

/**
 * @brief Get group_id of the flow that is created
 * internally for the rss_id's fwd.
 *
 * @return
 * 0 on success, negative on failure.
 */
int
dpdk_shared_rss_get_group(uint32_t rss_id, uint32_t *group_id);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* DPDK_SHARED_RSS_H_ */
