/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#include <errno.h>

#include "dpdk_table_sws.h"
#include "dpdk_table.h"

#include <doca_log.h>

DOCA_LOG_REGISTER(dpdk_flow_sws);

struct dpdk_table_port_ctx {
	bool set;
};

static struct dpdk_table_port_ctx dummy_ctx;

static int
dpdk_table_sws_init(struct dpdk_table_cfg *cfg)
{
	DOCA_LOG_DBG("Initialized dpdk flow work module to be SW steering");
	return 0;
}

static int
dpdk_table_sws_cleanup(void)
{
	DOCA_LOG_DBG("Cleanup dpdk flow SW steering module");
	return 0;
}

static struct dpdk_table_port_ctx *
dpdk_table_sws_port_hook(uint16_t port_id)
{
	return &dummy_ctx;
}

static void
dpdk_table_sws_port_unhook(struct dpdk_table_port_ctx *ctx)
{
}

static int
dpdk_table_sws_create(struct dpdk_table_params *dpdk_table_params,
		      struct dpdk_table_port_ctx *ctx,
		      struct dpdk_table *table)
{
	return 0;
}

static int
dpdk_table_sws_destroy(struct dpdk_table_port_ctx *ctx, struct dpdk_table *table)
{
	return 0;
}

static struct dpdk_table_ops sw_steering_ops = {
	.module_init = dpdk_table_sws_init,
	.module_cleanup = dpdk_table_sws_cleanup,
	.port_hook = dpdk_table_sws_port_hook,
	.port_unhook = dpdk_table_sws_port_unhook,
	.table_create = dpdk_table_sws_create,
	.table_destroy = dpdk_table_sws_destroy
};

struct dpdk_table_ops *
dpdk_table_sws_get_ops(void)
{
	return &sw_steering_ops;
}
