/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DPDK_METER_PIPE_H_
#define DPDK_METER_PIPE_H_

#include <stdio.h>

#include "dpdk_pipe.h"

#ifdef __cplusplus
extern "C" {
#endif

int
dpdk_meter_pipe_create(struct doca_flow_pipe *pipe,
		       uint16_t pipe_queue,
		       const struct doca_flow_monitor *mon,
		       const struct doca_flow_fwd *fwd);

void
dpdk_meter_pipe_fwd_update(const struct doca_flow_fwd *fwd,
			   struct doca_flow_pipe *pipe,
			   struct doca_flow_fwd *update_fwd,
			   bool *is_new_fwd);

void
dpdk_meter_pipe_destroy(struct doca_flow_pipe *pipe);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* DPDK_METER_PIPE_H_ */
