/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DPDK_PIPE_HASH_H_
#define DPDK_PIPE_HASH_H_

#include "dpdk_pipe_actions.h"
#include "dpdk_pipe_legacy.h"

#ifdef __cplusplus
extern "C" {
#endif

struct dpdk_pipe_type_ops *
dpdk_pipe_hash_get_ops(void);

int
dpdk_pipe_hash_build_set_index_action(struct dpdk_pipe *dpdk_pipe,
				      struct dpdk_pipe_q_ctx *pipe_q,
				      int arc_arr_idx,
				      uint32_t index);

int
dpdk_pipe_hash_modify_set_index_action(struct dpdk_action_entry *action_entry,
				       uint32_t index);

void
dpdk_pipe_hash_build_index_match(struct doca_flow_match *match,
				 struct doca_flow_match *match_mask);

void
dpdk_pipe_hash_modify_index_match(struct doca_flow_match *match, uint32_t index);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* DPDK_PIPE_HASH_H_ */
