/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#include "engine_spinlock.h"

void
engine_spinlock_init(struct engine_spinlock *spinlock)
{

	pthread_spin_init(&spinlock->lock, 0);
}

void
engine_spinlock_lock(struct engine_spinlock *spinlock)
{
	pthread_spin_lock(&spinlock->lock);
}

void
engine_spinlock_unlock(struct engine_spinlock *spinlock)
{
	pthread_spin_unlock(&spinlock->lock);
}
