/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef ENGINE_SPINLOCK_H_
#define ENGINE_SPINLOCK_H_

#include <stdint.h>
#include <pthread.h>

#ifdef __cplusplus
extern "C" {
#endif

struct engine_spinlock {
	pthread_spinlock_t lock;
};

/**
 * @brief Initialize engine spinlock
 */
void
engine_spinlock_init(struct engine_spinlock *spinlock);

/**
 * @brief Lock engine spinlock
 */
void
engine_spinlock_lock(struct engine_spinlock *spinlock);

/**
 * @brief Unlock engine spinlock
 */
void
engine_spinlock_unlock(struct engine_spinlock *spinlock);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* ENGINE_SPINLOCK_H_ */
