/*
 * Copyright (c) 2021 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef ID_POOL_H_
#define ID_POOL_H_

#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif

#define ID_POOL_NAME_LEN 32

struct id_pool;

struct id_pool_cfg {
	int size;
	int min;
	int nb_caches;
	char name[ID_POOL_NAME_LEN];
};

struct id_pool *id_pool_create(struct id_pool_cfg *cfg);
void id_pool_destroy(struct id_pool *pool);
uint32_t *id_pool_alloc(struct id_pool *pool, int qidx);
void id_pool_free(struct id_pool *pool, int qidx, uint32_t *id);

#ifdef __cplusplus
}
#endif

#endif /* ID_POOL_H_ */
