/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef UTILS_DF_TRANSLATE_H_
#define UTILS_DF_TRANSLATE_H_

#include "doca_flow_net.h"
#include "doca_flow.h"

bool
utils_df_translate_is_mac_ignored(const uint8_t *mac_addr);

bool
utils_df_translate_is_mac_changeable(const uint8_t *mac_addr);

void
utils_df_translate_set_mac_changeable(uint8_t *mac_addr);

void
utils_df_translate_copy_mac(const uint8_t *src_mac_addr, uint8_t *dst_mac_addr);

void
utils_df_translate_copy_mac_with_mask(const uint8_t *src_mac_addr, const uint8_t *mac_mask_addr, uint8_t *dst_mac_addr);

bool
utils_df_translate_is_ip_ignored(const struct doca_flow_ip_addr *ip_addr);

bool
utils_df_translate_is_ip_changeable(const struct doca_flow_ip_addr *ip_addr);

void
utils_df_translate_set_ip_changeable(struct doca_flow_ip_addr *ip_addr);

void
utils_df_translate_copy_ip_with_mask(const struct doca_flow_ip_addr *ip_addr, const uint8_t *ip_mask_addr, uint8_t *dst_addr);

void
utils_df_translate_copy_ip(const struct doca_flow_ip_addr *ip_addr, uint8_t *dst_addr);

void
utils_df_translate_set_vni_changeable(void *vni_addr);

bool
utils_df_translate_is_fwd_changeable(const struct doca_flow_fwd *fwd);

bool
utils_df_translate_is_l4_type_specific(uint8_t l4_type);

bool
utils_df_translate_is_nisp_ignored(const void *nisp);

bool
utils_df_translate_is_nisp_changeable(const void *nisp);

bool
utils_df_translate_is_audp_ignored(const void *audp);

bool
utils_df_translate_is_audp_changeable(const void *audp);

bool
utils_df_translate_is_esp_ignored(const void *esp);

bool
utils_df_translate_is_esp_changeable(const void *esp);

bool
utils_df_translate_is_shared_resource_id_specific(uint32_t shared_resource_id);

bool
utils_df_translate_is_shared_resource_id_ignored(uint32_t shared_resource_id);

bool
utils_df_translate_is_shared_resource_id_changeable(uint32_t shared_resource_id);
#endif /* UTILS_DF_TRANSLATE_H_ */
