/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DOCA_IPSEC_IMP_H_
#define DOCA_IPSEC_IMP_H_

#include <infiniband/mlx5dv.h>
#include <infiniband/verbs.h>
#include <stdint.h>
#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

struct doca_ipsec_sa {
	struct mlx5dv_devx_obj *devx_ipsec_obj;
	struct mlx5dv_devx_obj *devx_key_obj;
	struct doca_dev *dev;
	struct doca_ipsec_sa_attrs attr;
	uint32_t id;
	uint32_t key_id;
	uint64_t raw_key[8];
};

struct mlx5dv_devx_obj *sa_create(struct doca_ipsec_sa *sa);

doca_error_t sa_destroy(const struct doca_ipsec_sa *sa);

inline uint32_t
priv_ipsec_sa_to_id(const struct doca_ipsec_sa *sa)
{
	return sa->id;
}

#ifdef __cplusplus
}
#endif

#endif
