/*
 * Copyright (c) 2022 NVIDIA CORPORATION & AFFILIATES, ALL RIGHTS RESERVED.
 *
 * This software product is a proprietary product of NVIDIA CORPORATION &
 * AFFILIATES (the "Company") and all right, title, and interest in and to the
 * software product, including all associated intellectual property rights, are
 * and shall remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 *
 */

#ifndef DOCA_IPSEC_WORKQ_CTX_H_
#define DOCA_IPSEC_WORKQ_CTX_H_

#include <stdint.h>
#include <doca_dev.h>
#include <doca_ctx.h>
#include "doca_ipsec.h"

#ifdef __cplusplus
extern "C" {
#endif

struct doca_ipsec_job {
	enum doca_ipsec_job_types type;
	union doca_data user_data;
	struct doca_ipsec_sa_attrs attr;
	struct doca_ipsec_sa *sa;
	struct doca_ipsec_job *next_job;
};

struct ipsec_workq_ctx {
	struct doca_dev *dev;
	struct doca_ipsec_job *jobs_head;
	struct doca_ipsec_job *jobs_tail;
};

doca_error_t ipsec_workq_job_submit(struct ipsec_workq_ctx *ctx, struct doca_job const *job);

doca_error_t ipsec_workq_progress(struct ipsec_workq_ctx *ctx, struct doca_event *ev);

doca_error_t ipsec_workq_create(struct ipsec_workq_ctx **ctx, struct doca_dev *dev);

void ipsec_workq_ctx_destroy(struct ipsec_workq_ctx *ctx);

#ifdef __cplusplus
}
#endif

#endif
